package digital.laboratory.platform.entrustment.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import digital.laboratory.platform.common.core.util.R;
import digital.laboratory.platform.entrustment.query.BaseQuery;
import digital.laboratory.platform.entrustment.service.EntrustApproveRecordService;
import digital.laboratory.platform.entrustment.vo.EntrustApproveRecordVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 委托审核记录
 *
 * @author chenjiangbao
 * @describe 委托审核记录
 */
@RestController
@RequestMapping("/papp/entrustApproveRecord")
@Api(tags = "018-委托审核记录")
public class EntrustApproveRecordController {

    @Resource
    private EntrustApproveRecordService entrustApproveRecordService;


    @ApiOperation("分页查询-委托审核记录")
    @PostMapping("/page")
    public R<IPage<EntrustApproveRecordVO>> page(@RequestBody BaseQuery query) {
        IPage<EntrustApproveRecordVO> page =  entrustApproveRecordService.voPage(query);
        return R.ok(page);
    }
}
