package digital.laboratory.platform.entrustment.controller;

import digital.laboratory.platform.common.core.util.R;
import digital.laboratory.platform.entrustment.service.ExcelOperationService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author ChenJiangBao
 * @version 1.0
 * @description: excel上传接口控制器
 * @date 2025/4/16 9:48
 */
@RestController
@RequestMapping("/papp/excel")
@Api(tags = "20-excel上传接口控制器接口管理", description = "excel上传接口控制器接口管理")
public class ExcelOperationController {

    @Resource
    private ExcelOperationService excelOperationService;

    @ApiOperation("上传两社人员名单excel文件")
    @PostMapping("/uploadHairInspect")
    public R<Boolean> uploadHairInspectExcel(@RequestPart("file") MultipartFile file, @RequestParam("entrustId") String entrustId) {
        try {
            Boolean success = excelOperationService.uploadHairInspectExcel(file, entrustId);
            return R.ok(success);
        } catch (Exception e) {
            e.printStackTrace();
            return R.failed(e.getMessage());
        }
    }

    @ApiOperation("根据委托单位去导出对应的委托案件信息")
    @GetMapping("/exportByEntrustOrg")
    public void exportByEntrustOrg(@RequestParam("year") Integer year, HttpServletResponse response) throws IOException {
        excelOperationService.exportByEntrustOrg(year, response);
    }
}
