package digital.laboratory.platform.entrustment.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

/**
 * 申请修改委托消息表 审核 DTO类
 * @TableName b_entrust_alter_apply
 */
@Data
@ApiModel(value = "EntrustAlterApplyApproveDTO", description = "申请修改委托消息表 审核 DTO类, 传递参数")
public class EntrustAlterApplyApproveDTO {
    /**
     * 主键标识
     */
    @ApiModelProperty(value = "主键标识")
    @NotBlank(message = "请选择审核的记录！")
    private String id;

    /**
     * 原因
     */
    @ApiModelProperty(value = "原因")
    private String reason;

    @ApiModelProperty(value = " 0 不通过 | 1 通过")
    private Integer opCode;
}