package digital.laboratory.platform.entrustment.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

/**
 * 申请修改委托消息表 DTO类
 * @TableName b_entrust_alter_apply
 */
@Data
@ApiModel(value = "EntrustAlterApplyDTO", description = "申请修改委托消息表 DTO类, 传递参数")
public class EntrustAlterApplyDTO {
    /**
     * 主键标识
     */
    @ApiModelProperty(value = "主键标识")
    private String id;

    /**
     * 关联的委托id
     */
    @ApiModelProperty(value = "关联的委托id")
    @NotBlank(message = "关联的委托id不能为空!")
    private String entrustId;

    @ApiModelProperty(value = "申请原因")
    private String applyReason;

    @ApiModelProperty(value = " 0 保存 | 1 提交 (如果调用的是修改接口 1则是撤销操作)")
    private Integer opCode;
}