package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import digital.laboratory.platform.common.mybatis.base.BaseEntity;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 委托审核记录
 * @TableName b_entrust_approve_record
 */
@Data
@TableName(value ="b_entrust_approve_record")
public class EntrustApproveRecord extends BaseEntity {
    /**
     * 主键标识
     */
    @TableId(value = "ID", type = IdType.ASSIGN_ID)
    private String id;

    /**
     * 审核关联的委托id
     */
    private String entrustId;

    /**
     * 审核类型， 目前 0 代表 审核不通过
     */
    private Integer approveType;

    /**
     * 意见
     */
    private String comments;

    /**
     * 用户id
     */
    private String userId;

    /**
     * 机构id
     */
    private String orgId;

    /**
     * 审核时间
     */
    private LocalDateTime approveTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}
