package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.*;
import digital.laboratory.platform.common.mybatis.base.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 委托检材--检出定性定量结果信息
 * @TableName b_entrust_material_checkout_result
 */
@TableName(value ="b_entrust_material_checkout_result", autoResultMap = true)
@Data
public class EntrustMaterialCheckoutResult extends BaseEntity {
    /**
     * 委托检材id
     */
    @TableId(value = "entrust_material_id", type = IdType.ASSIGN_ID)
    private String id;

    /**
     * 委托检材id
     */
    @ApiModelProperty(value = "委托id")
    private String entrustId;

    /**
     * 定性结果
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String qualitativeResult;

    /**
     * 定量结果
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String quantitativeResult;

    /**
     * 代谢物结果
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String metaboliteResult;

    /**
     * 其他鉴定结果
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String otherResult;

    /**
     * 检出结果的备注信息
     */
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String checkoutRemark;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
