package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @ClassName EntrustOfThirdSys
 * @Description TODO
 * @Author xy
 * @Date 2023/6/13 11:58
 * @Version 1.0
 **/
@Data
@TableName(value = "b_entrust_thirdsys", autoResultMap = true)
public class EntrustOfThirdSys {

    private  String id;
    private String entrustMainId;//主系统委托书ID
    private String entrustSerialNumber;//委托编号
    private String acceptSerialNumber;//受理编号 -完整编号
    private String serialNumber;//受理编号，短编号
    private Integer serialYear;//年序号
    private Integer serialIndex;//索引序号
    //provinceAuditing:省级审核中, provinceAuditRollback:省级审核退回, acceptAuditing:受理审核中,
    // acceptAuditRollback:受理审核退回,toAccept:待受理, accepted:已受理, toAnalyse:待鉴定, analysed:鉴定完成
    private String status;
    private String provinceName;
    private String provinceCode;
    private String provinceDeptName;
    private LocalDateTime submitTime;
    private LocalDateTime acceptTime;
    private LocalDateTime finishTime;
    private String entrustOrganization;//委托鉴定单位
    private LocalDateTime scheduledDate;//预约送检日期
    private String createUserDeptRegionCode;//提交人单位所在地区编码
    private String caseName;
    private String caseCode;
    private String caseRemark;
    private String materialType;//检材类型  inVitro:缴获物, inVivo:生物样本, other:其他
    private String materialDescribe; //检材描述
    private String entrustRequirement;//鉴定要求
    private String entrustMethod;//鉴定方法
    private  String originalIdentification;//原鉴定情况
    private String reportSendType;//报告发放方式
    private  String reportSendAddress;//报告发送地址
    private LocalDateTime analysisStartTime;//鉴定开始时间
    private LocalDateTime analysisEndTime;//鉴定结束时间
    private String samplingMethod;//这个属性要在受理之后才会有，表示的意思是：样本的描述，比如 检材全部为分析样  检材全部为留存样，检材分装为分析样和留存样

    //送检人信息
    private String deliverer1Name;
    private String deliverer1Position;
    private String deliverer1CardType;
    private String deliverer1CertificatesCode;
    private String deliverer1Phone;

    private String deliverer2Name;
    private String deliverer2Position;
    private String deliverer2CardType;
    private String deliverer2CertificatesCode;
    private String deliverer2Phone;
}
