package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import digital.laboratory.platform.common.mybatis.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 鉴定表,一个鉴定可能会有多个委托
 *
 * @author Zhang Xiaolong created at  2022-07-15
 * @describe 鉴定表,一个鉴定可能会有多个委托 实体类
 */
@Data
@TableName(value = "b_identification", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "鉴定表,一个鉴定可能会有多个委托")
public class Identification extends BaseEntity {

    /**
     * id
     */
    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 鉴定号,受理号
     */
    @ApiModelProperty(value = "鉴定号,受理号")
    private String identificationNo;

    /**
     * 状态: 0=鉴定中,-1=已终止, 1=已结束
     */
    @ApiModelProperty(value = "状态: 0=鉴定中,-1=已终止, 1=已结束")
    private Integer status;

}
