package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import digital.laboratory.platform.common.mybatis.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 样品包入库出库日志
 *
 * @author Zhang Xiaolong created at  2022-07-15
 * @describe 样品包入库出库日志 实体类
 */
@Data
@TableName("b_sample_box_in_log")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "样品包入库出库日志")
public class SampleBoxInLog extends BaseEntity {

    /**
     * id
     */
        @TableId(value = "id", type = IdType.ASSIGN_UUID)
        @ApiModelProperty(value="id")
    private String id;

    /**
     * 样品id
     */
    @ApiModelProperty(value="样品id")
    private String boxId;

    /**
     * 是否入库
     */
    @ApiModelProperty(value="是否入库")
    private Boolean isIn;

    /**
     * 入库出库原因编码
     */
    @ApiModelProperty(value="入库出库原因编码")
    private Integer reason;

    /**
     * 出入库当事人
     */
    @ApiModelProperty(value="出入库当事人")
    private String personId;

    /**
     * 分包的来源盒子id
     */
    @ApiModelProperty(value="分包的来源盒子id")
    private String fromBox;

    /**
     * 合包的去向盒子id
     */
    @ApiModelProperty(value="合包的去向盒子id")
    private String toBox;

    /**
     * 检材仓库管理员
     */
    @ApiModelProperty(value="检材仓库管理员")
    private String storeKeeper;


}
