package digital.laboratory.platform.entrustment.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import digital.laboratory.platform.common.mybatis.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 采集员
 *
 * @author Zhang Xiaolong created at  2022-08-25
 * @describe 采集员 实体类
 */
@Data
@TableName(value = "b_taker", autoResultMap = true)
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "采集员")
public class Taker extends BaseEntity {

    /**
     * id
     */
        @TableId(value = "id", type = IdType.ASSIGN_UUID)
        @ApiModelProperty(value="id")
    private String id;

    /**
     * 采集员拥有者userId
     */
    @ApiModelProperty(value="采集员拥有者userId")
    private String ownerUserId;

    /**
     * 采集员姓名
     */
    @ApiModelProperty(value="采集员姓名")
    private String name;

    /**
     * 采集员职务
     */
    @ApiModelProperty(value="采集员职务")
    private String position;

    /**
     * 采集员证件名称
     */
    @ApiModelProperty(value="采集员证件名称")
    private String cert;

    /**
     * 采集员证件编号
     */
    @ApiModelProperty(value="采集员证件编号")
    private String idnum;

    /**
     * 采集员电话
     */
    @ApiModelProperty(value="采集员电话")
    private String phone;


}
