package digital.laboratory.platform.entrustment.enums;

import lombok.Getter;

/**
 * @author ChenJiangBao
 * @version 1.0
 * @description: 委托信息导出excel表头枚举
 * @date 2025/7/14 10:47
 */
@Getter
public enum EntrustExportHeaderEnum {
    CASE_NAME("caseName", "案件名称"),
    CASE_BRIEF("caseBrief", "案情简要"),
    HAPPEN_TIME("happenTime", "案发时间"),
    SUSPECT_INFO("suspectInfo", "嫌疑人信息"),
    CLIENT_ORG_NAME("clientOrgName", "委托单位"),
    ENTRUST_TIME("entrustmentTime", "送检时间"),
    ACCEPT_NO("acceptNo", "受理编号"),
    ACCEPT_TIME("acceptTime", "受理时间"),
    ENTRUST_REQUIREMENT("entrustRequirement", "鉴定要求"),
    MATERIAL_CHARACTER("materialCharacterDesc", "性状描述"),
    MATERIAL_COUNT("materialCount", "检材数量"),
    MATERIAL_RESULT("materialResult", "检材检测结果");

    private final String field;     // 字段名，用于匹配数据
    private final String header;    // Excel列名，用于显示

    EntrustExportHeaderEnum(String field, String header) {
        this.field = field;
        this.header = header;
    }
}
