package digital.laboratory.platform.entrustment.event;

import lombok.Getter;
import org.springframework.context.ApplicationEvent;

import java.time.Clock;

/**
 * 推送数据到LabsCare 数据平台上的spring 事件
 */
@Getter
public class PushDataToLabsCareEvent extends ApplicationEvent {

    /**
     * 委托id
     */
    private final String entrustId;

    /**
     * 推送的数据类型， 1 鉴定委托书数据 | 2 鉴定事项确认书数据
     */
    private final Integer pushType;

    public PushDataToLabsCareEvent(Object source, String entrustId, Integer pushType) {
        super(source);
        this.entrustId = entrustId;
        this.pushType = pushType;
    }

    public PushDataToLabsCareEvent(Object source, Clock clock, String entrustId, Integer pushType) {
        super(source, clock);
        this.entrustId = entrustId;
        this.pushType = pushType;
    }


}
