package digital.laboratory.platform.entrustment.service;

import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author ChenJiangBao
 * @version 1.0
 * @description: excel上传服务层接口
 * @date 2025/4/16 11:55
 */
public interface ExcelOperationService {

    /**
     * 上传两社人员名单excel文件
     * @param file
     * @param entrustId
     * @return
     */
    Boolean uploadHairInspectExcel(MultipartFile file, String entrustId) throws Exception;

    /**
     * 根据当前用户的机构id查询属于这个机构的委托信息
     *
     * @param year
     * @param response
     */
    void exportByEntrustOrg(Integer year, HttpServletResponse response) throws IOException;

}
