package digital.laboratory.platform.entrustment.vo;

import digital.laboratory.platform.entrustment.entity.CaseEvent;
import digital.laboratory.platform.entrustment.entity.CaseEvidence;
import digital.laboratory.platform.entrustment.entity.Suspect;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
public class CaseEventVO extends CaseEvent {

//	String caseTypeName;
//	String criminalTypeName;
	String caseOrgName;         // 案属机构名称
	String caseOrgShortName;    // 案属机构名称
	String caseCreateUserName;
	String caseUpdateUserName;
	String caseAreaName;        // 案发地的名字(到县一级, 根据 case_area 代码查询到的名字)

//	String caseOwnOrgName;      // 案属机构名称
	List<String> caseOwnOrgAncestors; // 案属机构的祖先 id,  json 字符串数组

	int caseEntrustmentCount;
	int caseEvidenceCount;
	List<CaseEvidence> caseEvidenceList;

	@ApiModelProperty("受理编号")
	private String acceptNo;

	@ApiModelProperty(value="委托类型: 0=常规毒品, 1=生物样本")
	private Integer entrustmentType;

	@ApiModelProperty(value="原鉴定结果（鉴定情况），" +
			"常规毒品：首次鉴定、初筛（不要报告、只要结果）、补充鉴定、重新鉴定；" +
			"生物样本：首次鉴定、初筛（不要报告、只要结果）、涉缅人员、自愿戒治人员、补充鉴定、重新鉴定")
	private String oldIdentificationResult;

	private List<Suspect> suspects;
}
