package digital.laboratory.platform.entrustment.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 委托检材--检出定性定量结果信息
 *
 * @TableName b_entrust_material_checkout_result
 */
@Data
@ApiModel(value = "EntrustMaterialCheckoutResultVO", description = "委托检材--检出定性定量结果信息VO")
public class EntrustMaterialCheckoutResultVO {
    /**
     * 委托检材id
     */
    @ApiModelProperty("委托检材id列表， 支持批量")
    private String id;

    @ApiModelProperty(value = "检材受理编号")
    private String acceptNo;

    /**
     * 委托检材id
     */
    @ApiModelProperty(value = "委托id")
    private String entrustId;

    /**
     * 检材名称
     */
    @ApiModelProperty(value = "检材名称")
    private String name;

    /**
     * 定性结果
     */
    @ApiModelProperty("定性结果")
    private String qualitativeResult;


    /**
     * 定量结果
     */
    @ApiModelProperty("定量结果")
    private String quantitativeResult;

    /**
     * 定量结果
     */
    @ApiModelProperty("定量结果")
    private String metaboliteResult;

    /**
     * 其他鉴定结果
     */
    @ApiModelProperty("其他鉴定结果")
    private String otherResult;

    /**
     * 检出结果的备注信息
     */
    @ApiModelProperty("检出结果的备注信息")
    private String checkoutRemark;

    @ApiModelProperty(value = "委托检材顺序号，由系统根据录入顺序生成")
    private Integer orderNo;

    @ApiModelProperty(value = "检材性状")
    private String form;


    @ApiModelProperty(value = "提取时间--贵阳新增需求")
    private LocalDateTime drawTime;

    @ApiModelProperty(value = "提取地点--贵阳新增需求")
    private String drawPlace;

    @ApiModelProperty(value = "嫌疑人身份证号码")
    private String suspectIdNum;


}
