package digital.laboratory.platform.entrustment.vo;

import digital.laboratory.platform.entrustment.entity.Identification;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 这个 VO 类是 Identification 的扩展。
 * 这个类的目的是供用户在创建新的委托时，可以选择某个案件目前有哪些"鉴定"存在, 以便新的委托可以作为某个鉴定的补充委托。
 * 这个类提供一个鉴定列表, 其实主要内容是委托列表, 因为用户对“鉴定”不敏感, 对“委托”敏感, 所以这个 vo 的主要属性是委托相关的, 给用户看的
 */
@Data
public class IdentificationVO extends Identification {
	String entrustmentId;
	String entrustmentNo;
	LocalDateTime entrustmentTime;
	LocalDateTime acceptTime;
	Integer entrustmentStatus;
}
