package digital.laboratory.platform.entrustment.vo;

import digital.laboratory.platform.entrustment.entity.Suspect;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

@Data
public class SuspectDetectionVO extends Suspect {
    /**
     * 案件名称任务名称
     */
    @ApiModelProperty(value="案件名称")
    private String caseName;

    /**
     * 案情简要
     */
    @ApiModelProperty(value="案情简要")
    private String caseBrief;

    /**
     * 案件编号
     */
    @ApiModelProperty(value="案件编号")
    private String acceptNo;


    /**
     * 案发时间
     */
    @ApiModelProperty(value="案发时间")
    private LocalDate happenTime;

    /**
     * 推送时间
     */
    @ApiModelProperty(value="推送时间")
    private LocalDateTime pushTime;

    /**
     * 检材检出结果
     */
    @ApiModelProperty(value = "检材检测结果")
    List<EntrustMaterialCheckoutResultVO> results;

}
